<html>

<head>
    <meta charset="UTF-8">
    <link rel="stylesheet" href="css/styles.css">

    <script src="js/htmldiff.js" type="text/javascript"></script>
    <link rel="stylesheet" href="css/htmldiff.css">

</head>

<body>
    <a href="index.html">👈 Back</a>
    <h1>Diff Tool</h1>
    <div style="display:inline-block;width:49%">
        <label>OLD:</label><br>
        <textarea id="old" cols="50" rows="10">{ 
        "z": false, 
        "a": true, 
        "a": false 
    }</textarea>
    </div>
    <div style="display:inline-block;width:49%">
        <label>NEW:</label><br>
        <textarea id="new" cols="50" rows="10">{ 
        "x": false, 
        "a": true, 
        "a": false 
    }</textarea>
    </div>
    <br><button id="diffJSONObjectsButton">Sort keys, Unique keys, Diff JSON</button>
    <button id="diffSortedPlainTextButton">Sort alphabetically, Diff Plain Text</button>
    <button id="diffPlainTextButton">Diff Plain Text</button>
    <div id="console"></div>
    <div id="output"></div>
    <script>
        window.onload = function () {
            document.getElementById("diffJSONObjectsButton").addEventListener("click", function () {
                consoleDivLog("")
                sortJSONKeys("old")
                sortJSONKeys("new")
                populateAllData("output")
            });
            document.getElementById("diffSortedPlainTextButton").addEventListener("click", function () {
                consoleDivLog("")
                sortAlphabetically("old")
                sortAlphabetically("new")
                populateAllData("output")
            })
            document.getElementById("diffPlainTextButton").addEventListener("click", function () {
                consoleDivLog("")
                populateAllData("output")
            });
        }

        function sortObject(obj) {
            return Object.keys(obj).sort().reduce(function (result, key) {
                result[key] = obj[key];
                return result;
            }, {});
        }

        function sortJSONKeys(textAreaId) {
            // console.log(`sorting keys `)
            try {
                const object = JSON.parse(document.getElementById(textAreaId).value);
                // console.log(object)
                document.getElementById(textAreaId).value = JSON.stringify(sortObject(object), null, 2)
            } catch (e) {
                consoleDivLog(`Warning: ${textAreaId} JSON error: ${e}`)
            }
        }

        function sortAlphabetically(textAreaId) {
            const lines = document.getElementById(textAreaId).value.split("\n");
            document.getElementById(textAreaId).value = lines.sort().join("\n")
        }

        function consoleDivLog(string) {
            document.getElementById("console").innerHTML = string
        }

        function populateAllData(id) {
            const value1 = document.getElementById("old").value.replaceAll("\n", "<br>")
            const value2 = document.getElementById("new").value.replaceAll("\n", "<br>")
            if (value1.length == 0) {
                consoleDivLog(`Warning: "old" is empty`)
            }
            if (value2.length == 0) {
                consoleDivLog(`Warning: "new" is empty`)
            }

            const output = htmldiff(value1, value2)
            document.getElementById(id).innerHTML = `<h2>Output</h2>${output}`
        }
    </script>
</body>

</html>